package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.GoodsSpecService;
import com.gxwebsoft.shop.entity.GoodsSpec;
import com.gxwebsoft.shop.param.GoodsSpecParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品多规格控制器
 *
 * @author 科技小王子
 * @since 2024-04-03 16:06:23
 */
@Api(tags = "商品多规格管理")
@RestController
@RequestMapping("/api/shop/goods-spec")
public class GoodsSpecController extends BaseController {
    @Resource
    private GoodsSpecService goodsSpecService;

    @ApiOperation("分页查询商品多规格")
    @GetMapping("/page")
    public ApiResult<PageResult<GoodsSpec>> page(GoodsSpecParam param) {
        // 使用关联查询
        return success(goodsSpecService.pageRel(param));
    }

    @ApiOperation("查询全部商品多规格")
    @GetMapping()
    public ApiResult<List<GoodsSpec>> list(GoodsSpecParam param) {
        // 使用关联查询
        return success(goodsSpecService.listRel(param));
    }

    @ApiOperation("根据id查询商品多规格")
    @GetMapping("/{id}")
    public ApiResult<GoodsSpec> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(goodsSpecService.getByIdRel(id));
    }

    @ApiOperation("添加商品多规格")
    @PostMapping()
    public ApiResult<?> save(@RequestBody GoodsSpec goodsSpec) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        //  goodsSpec.setUserId(loginUser.getUserId());
        // }
        if (goodsSpecService.save(goodsSpec)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商品多规格")
    @PutMapping()
    public ApiResult<?> update(@RequestBody GoodsSpec goodsSpec) {
        if (goodsSpecService.updateById(goodsSpec)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商品多规格")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (goodsSpecService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商品多规格")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<GoodsSpec> list) {
        if (goodsSpecService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商品多规格")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<GoodsSpec> batchParam) {
        if (batchParam.update(goodsSpecService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商品多规格")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (goodsSpecService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
